%global debug_package %{nil}
%global scala_version 2.13

Name:           kafka
Version:        3.9.0
Release:        %autorelease
Summary:        Open-source distributed event streaming platform
License:        Apache-2.0
URL:            https://kafka.apache.org/
Source0:        https://dlcdn.apache.org/kafka/%{version}/kafka-%{version}-src.tgz
Source1:        kafka.service
Source2:        kafka-start-server.sh


BuildArch: noarch


BuildRequires: java-21-openjdk-devel
BuildRequires: systemd-rpm-macros
BuildRequires: tar


Requires: java-21-openjdk-headless
Requires: bash grep gawk sed


%description
Apache Kafka is an open-source distributed event streaming platform used by thousands of companies for high-performance data pipelines, streaming analytics, data integration, and mission-critical applications.


%prep
%autosetup -n %{name}-%{version}-src


%build
./gradlew releaseTarGz -PscalaVersion=%{scala_version}


%install
install -D --directory --mode=0755 %{buildroot}%{_datadir}/java

tar --extract --gzip --file core/build/distributions/kafka_%{scala_version}-%{version}.tgz --directory %{buildroot}%{_datadir}/java
tar --extract --gzip --file core/build/distributions/kafka_%{scala_version}-%{version}-site-docs.tgz --directory .
mv %{buildroot}%{_datadir}/java/kafka_%{scala_version}-%{version} %{buildroot}%{_datadir}/java/kafka

rm -rf %{buildroot}%{_datadir}/java/kafka/bin/windows \
    %{buildroot}%{_datadir}/java/kafka/licenses \
    %{buildroot}%{_datadir}/java/kafka/site-docs \
    %{buildroot}%{_datadir}/java/kafka/LICENSE \
    %{buildroot}%{_datadir}/java/kafka/NOTICE

install -D --mode=0755 "%{SOURCE2}" %{buildroot}%{_datadir}/java/kafka/scripts/kafka-start-server.sh

install -D "%{SOURCE1}" %{buildroot}%{_unitdir}/kafka.service

install -D --directory --mode=0700 %{buildroot}%{_sharedstatedir}/kafka


%files
%doc README.md site-docs
%license LICENSE licenses/*
%{_datadir}/java/kafka/bin/*
%config(noreplace) %{_datadir}/java/kafka/config/*
%{_datadir}/java/kafka/libs/*
%{_datadir}/java/kafka/scripts/*
%{_unitdir}/kafka.service
%attr(700,kafka,kafka) %dir %{_sharedstatedir}/kafka


%pre
getent group kafka > /dev/null || groupadd --system kafka
getent passwd kafka > /dev/null || \
  useradd --system --home-dir %{_sharedstatedir}/kafka --gid kafka \
  -s /sbin/nologin -c "kafka daemon" kafka
exit 0


%post
%systemd_post kafka.service


%preun
%systemd_preun kafka.service


%postun
%systemd_postun kafka.service


%changelog
%autochangelog
